package bigint;use 5.010;use strict;use warnings;our$VERSION='0.51';use Exporter;our@ISA=qw(Exporter);our@EXPORT_OK=qw(PI e bpi bexp hex oct);our@EXPORT=qw(inf NaN);use overload;my@faked=qw/round_mode accuracy precision div_scale/;our ($AUTOLOAD,$_lite);sub AUTOLOAD {my$name=$AUTOLOAD;$name =~ s/.*:://;no strict 'refs';for my$n (@faked){if ($n eq $name){*{"bigint::$name"}=sub {my$self=shift;no strict 'refs';if (defined $_[0]){return Math::BigInt->$name($_[0])}return Math::BigInt->$name()};return &$name}}require Carp;Carp::croak ("Can't call bigint\-\>$name, not a valid method")}sub upgrade {$Math::BigInt::upgrade}sub _binary_constant {my$string=shift;return Math::BigInt->new($string)if$string =~ /^0[bx]/;Math::BigInt->from_oct($string)}sub _float_constant {my$float=shift;return$float if ($float =~ /^[+-]?[0-9]+$/);return$float if ($float =~ /^[+-]?[0-9]+\.?[eE]\+?[0-9]+$/);return '0' if ($float =~ /^[+-]?[0]*\.[0-9]+$/);if ($float =~ /^[+-]?[0-9]+\.[0-9]*$/){$float =~ s/\..*//;return$float}my ($mis,$miv,$mfv,$es,$ev)=Math::BigInt::_split($float);return$float if!defined$mis;my$ec=int($$ev);my$sign=$$mis;$sign='' if$sign eq '+';if ($$es eq '-'){if ($ec >= length($$miv)){return '0'}return$sign .substr($$miv,0,length($$miv)- $ec)}if ($ec >= length($$mfv)){$ec -= length($$mfv);return$sign.$$miv.$$mfv if$ec==0;return$sign.$$miv.$$mfv.'E'.$ec}$mfv=substr($$mfv,0,$ec);$sign.$$miv.$mfv}sub unimport {$^H{bigint}=undef;overload::remove_constant('binary','','float','','integer')}sub in_effect {my$level=shift || 0;my$hinthash=(caller($level))[10];$hinthash->{bigint}}use constant LEXICAL=>$] > 5.009004;sub _hex_core {my$str=shift;my$x;if ($str =~ s/ ^ (0?[xX])? ( [0-9a-fA-F]* ( _ [0-9a-fA-F]+ )* ) //x){my$chrs=$2;$chrs =~ tr/_//d;$chrs='0' unless CORE::length$chrs;$x=Math::BigInt -> from_hex($chrs)}else {$x=Math::BigInt -> bzero()}if (CORE::length($str)){require Carp;Carp::carp(sprintf("Illegal hexadecimal digit '%s' ignored",substr($str,0,1)))}return$x}sub _oct_core {my$str=shift;$str =~ s/^\s*//;return _hex_core($str)if$str =~ /^0?[xX]/;my$x;if ($str =~ /^0?[bB]/){if ($str =~ s/ ^ (0?[bB])? ( [01]* ( _ [01]+ )* ) //x){my$chrs=$2;$chrs =~ tr/_//d;$chrs='0' unless CORE::length$chrs;$x=Math::BigInt -> from_bin($chrs)}if (CORE::length($str)){require Carp;Carp::carp(sprintf("Illegal binary digit '%s' ignored",substr($str,0,1)))}return$x}if ($str =~ s/ ^ ( [0-7]* ( _ [0-7]+ )* ) //x){my$chrs=$1;$chrs =~ tr/_//d;$chrs='0' unless CORE::length$chrs;$x=Math::BigInt -> from_oct($chrs)}if (CORE::length($str)){my$chr=substr($str,0,1);if ($chr eq '8' || $chr eq '9'){require Carp;Carp::carp(sprintf("Illegal octal digit '%s' ignored",$chr))}}return$x}{my$proto=LEXICAL ? '_' : ';$';eval '
sub hex(' .$proto .') {' .<<'.';eval '
    my $str = @_ ? $_[0] : $_;
    _hex_core($str);
}
.
sub oct(' .$proto .') {' .<<'.'}my ($prev_oct,$prev_hex,$overridden);if (LEXICAL){eval <<'.'}sub _override {return if$overridden;$prev_oct=*CORE::GLOBAL::oct{CODE};$prev_hex=*CORE::GLOBAL::hex{CODE};no warnings 'redefine';*CORE::GLOBAL::oct=\&_oct;*CORE::GLOBAL::hex=\&_hex;$overridden++}sub import {my$self=shift;$^H{bigint}=1;if (LEXICAL){_override()}my$lib='';my$lib_kind='try';my@import=(':constant');my@a=@_;my$l=scalar @_;my$j=0;my ($ver,$trace);my ($a,$p);for (my$i=0;$i < $l;$i++,$j++){if ($_[$i]=~ /^(l|lib|try|only)$/){$lib_kind=$1;$lib_kind='lib' if$lib_kind eq 'l';$lib=$_[$i + 1]|| '';my$s=2;$s=1 if@a - $j < 2;splice@a,$j,$s;$j -= $s;$i++}elsif ($_[$i]=~ /^(a|accuracy)$/){$a=$_[$i + 1];my$s=2;$s=1 if@a - $j < 2;splice@a,$j,$s;$j -= $s;$i++}elsif ($_[$i]=~ /^(p|precision)$/){$p=$_[$i + 1];my$s=2;$s=1 if@a - $j < 2;splice@a,$j,$s;$j -= $s;$i++}elsif ($_[$i]=~ /^(v|version)$/){$ver=1;splice@a,$j,1;$j--}elsif ($_[$i]=~ /^(t|trace)$/){$trace=1;splice@a,$j,1;$j--}elsif ($_[$i]!~ /^(PI|e|bpi|bexp|hex|oct)\z/){die ("unknown option $_[$i]")}}my$class;$_lite=0;if ($trace){require Math::BigInt::Trace;$class='Math::BigInt::Trace'}else {if (!defined$a &&!defined$p){local@INC=@INC;pop@INC if$INC[-1]eq '.';if (eval {require Math::BigInt::Lite;1}){@import=();Math::BigInt::Lite->import(':constant');$_lite=1}}require Math::BigInt if$_lite==0;$class='Math::BigInt'}push@import,$lib_kind=>$lib if$lib ne '';$class->import(@import);bigint->accuracy($a)if defined$a;bigint->precision($p)if defined$p;if ($ver){print "bigint\t\t\t v$VERSION\n";print "Math::BigInt::Lite\t v$Math::BigInt::Lite::VERSION\n" if$_lite;print "Math::BigInt\t\t v$Math::BigInt::VERSION";my$config=Math::BigInt->config();print " lib => $config->{lib} v$config->{lib_version}\n";exit}overload::constant float=>sub {Math::BigInt->new(_float_constant(shift))};overload::constant binary=>sub {_binary_constant(shift)};my ($package)=caller();no strict 'refs';if (!defined *{"${package}::inf"}){$self->export_to_level(1,$self,@a)}}sub inf () {Math::BigInt->binf()}sub NaN () {Math::BigInt->bnan()}sub PI () {Math::BigInt->new(3)}sub e () {Math::BigInt->new(2)}sub bpi ($) {Math::BigInt->new(3)}sub bexp ($$) {my$x=Math::BigInt->new($_[0]);$x->bexp($_[1])}1;
    my $str = @_ ? $_[0] : $_;
    _oct_core($str);
}
.
sub _hex(_) {
    my $hh = (caller 0)[10];
    return $prev_hex ? &$prev_hex($_[0]) : CORE::hex($_[0])
      unless $$hh{bigint}||$$hh{bignum}||$$hh{bigrat};
    _hex_core($_[0]);
}

sub _oct(_) {
    my $hh = (caller 0)[10];
    return $prev_oct ? &$prev_oct($_[0]) : CORE::oct($_[0])
      unless $$hh{bigint}||$$hh{bignum}||$$hh{bigrat};
    _oct_core($_[0]);
}
.
