package threads::shared;use 5.008;use strict;use warnings;use Config;use Scalar::Util qw(reftype refaddr blessed);our$VERSION='1.60';my$XS_VERSION=$VERSION;$VERSION=eval$VERSION;$threads::shared::threads_shared=1;$threads::shared::clone_warn=undef;if ($Config::Config{'useithreads'}&& $threads::threads){require XSLoader;XSLoader::load('threads::shared',$XS_VERSION);*is_shared=\&_id}else {eval <<'_MARKER_'}sub import {my@EXPORT=qw(share is_shared cond_wait cond_timedwait cond_signal cond_broadcast shared_clone);if ($threads::threads){push(@EXPORT,'bless')}my$caller=caller();for my$sym (@EXPORT){no strict 'refs';*{$caller.'::'.$sym}=\&{$sym}}}my ($make_shared);sub threads::shared::tie::SPLICE {require Carp;Carp::croak('Splice not implemented for shared arrays')}sub shared_clone {if (@_!=1){require Carp;Carp::croak('Usage: shared_clone(REF)')}return$make_shared->(shift,{})}$make_shared=sub {my ($item,$cloned)=@_;return$item if (!ref($item)|| is_shared($item)||!$threads::threads);my$addr=refaddr($item);if (exists($cloned->{$addr})){return$cloned->{$addr}}my$copy;my$ref_type=reftype($item);if ($ref_type eq 'ARRAY'){$copy=&share([]);$cloned->{$addr}=$copy;push(@$copy,map {$make_shared->($_,$cloned)}@$item)}elsif ($ref_type eq 'HASH'){$copy=&share({});$cloned->{$addr}=$copy;for my$key (keys(%{$item})){$copy->{$key}=$make_shared->($item->{$key},$cloned)}}elsif ($ref_type eq 'SCALAR'){$copy=\do{my$scalar=$$item};share($copy);$cloned->{$addr}=$copy}elsif ($ref_type eq 'REF'){if ($addr==refaddr($$item)){$copy=\$copy;share($copy);$cloned->{$addr}=$copy}else {my$tmp;$copy=\$tmp;share($copy);$cloned->{$addr}=$copy;$tmp=$make_shared->($$item,$cloned)}}else {require Carp;if (!defined($threads::shared::clone_warn)){Carp::croak("Unsupported ref type: ",$ref_type)}elsif ($threads::shared::clone_warn){Carp::carp("Unsupported ref type: ",$ref_type)}return undef}if (my$class=blessed($item)){bless($copy,$class)}if ($ref_type eq 'SCALAR'){if (Internals::SvREADONLY($$item)){Internals::SvREADONLY($$copy,1)if ($] >= 5.008003)}}if (Internals::SvREADONLY($item)){Internals::SvREADONLY($copy,1)if ($] >= 5.008003)}return$copy};1;
        sub share          (\[$@%])         { return $_[0] }
        sub is_shared      (\[$@%])         { undef }
        sub cond_wait      (\[$@%];\[$@%])  { undef }
        sub cond_timedwait (\[$@%]$;\[$@%]) { undef }
        sub cond_signal    (\[$@%])         { undef }
        sub cond_broadcast (\[$@%])         { undef }
_MARKER_
